package cn.iocoder.yudao.module.mes.service.plan;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.plan.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.plan.PlanDO;
import cn.iocoder.yudao.module.mes.dal.mysql.plan.PlanMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link PlanServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(PlanServiceImpl.class)
public class PlanServiceImplTest extends BaseDbUnitTest {

    @Resource
    private PlanServiceImpl planService;

    @Resource
    private PlanMapper planMapper;

    @Test
    public void testCreatePlan_success() {
        // 准备参数
        PlanSaveReqVO createReqVO = randomPojo(PlanSaveReqVO.class).setId(null);

        // 调用
        Long planId = planService.createPlan(createReqVO);
        // 断言
        assertNotNull(planId);
        // 校验记录的属性是否正确
        PlanDO plan = planMapper.selectById(planId);
        assertPojoEquals(createReqVO, plan, "id");
    }

    @Test
    public void testUpdatePlan_success() {
        // mock 数据
        PlanDO dbPlan = randomPojo(PlanDO.class);
        planMapper.insert(dbPlan);// @Sql: 先插入出一条存在的数据
        // 准备参数
        PlanSaveReqVO updateReqVO = randomPojo(PlanSaveReqVO.class, o -> {
            o.setId(dbPlan.getId()); // 设置更新的 ID
        });

        // 调用
        planService.updatePlan(updateReqVO);
        // 校验是否更新正确
        PlanDO plan = planMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, plan);
    }

    @Test
    public void testUpdatePlan_notExists() {
        // 准备参数
        PlanSaveReqVO updateReqVO = randomPojo(PlanSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> planService.updatePlan(updateReqVO), PLAN_NOT_EXISTS);
    }

    @Test
    public void testDeletePlan_success() {
        // mock 数据
        PlanDO dbPlan = randomPojo(PlanDO.class);
        planMapper.insert(dbPlan);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbPlan.getId();

        // 调用
        planService.deletePlan(id);
       // 校验数据不存在了
       assertNull(planMapper.selectById(id));
    }

    @Test
    public void testDeletePlan_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> planService.deletePlan(id), PLAN_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetPlanPage() {
       // mock 数据
       PlanDO dbPlan = randomPojo(PlanDO.class, o -> { // 等会查询到
           o.setCode(null);
           o.setProductId(null);
           o.setTaskDetailId(null);
           o.setTaskId(null);
           o.setPlanNumber(null);
           o.setFinishNumber(null);
           o.setStatus(null);
           o.setPlanStartTime(null);
           o.setPlanEndTime(null);
           o.setStartTime(null);
           o.setEndTime(null);
           o.setProductionManagerId(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       planMapper.insert(dbPlan);
       // 测试 code 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setCode(null)));
       // 测试 productId 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setProductId(null)));
       // 测试 taskDetailId 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setTaskDetailId(null)));
       // 测试 taskId 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setTaskId(null)));
       // 测试 planNumber 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setPlanNumber(null)));
       // 测试 finishNumber 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setFinishNumber(null)));
       // 测试 status 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setStatus(null)));
       // 测试 planStartTime 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setPlanStartTime(null)));
       // 测试 planEndTime 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setPlanEndTime(null)));
       // 测试 startTime 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setStartTime(null)));
       // 测试 endTime 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setEndTime(null)));
       // 测试 productionManagerId 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setProductionManagerId(null)));
       // 测试 remark 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       planMapper.insert(cloneIgnoreId(dbPlan, o -> o.setCreateTime(null)));
       // 准备参数
       PlanPageReqVO reqVO = new PlanPageReqVO();
       reqVO.setCode(null);
       reqVO.setProductId(null);
       reqVO.setTaskDetailId(null);
       reqVO.setTaskId(null);
       reqVO.setPlanNumber(null);
       reqVO.setFinishNumber(null);
       reqVO.setStatus(null);
       reqVO.setPlanStartTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setPlanEndTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setStartTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setEndTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setProductionManagerId(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<PlanRespVO> pageResult = planService.getPlanPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbPlan, pageResult.getList().get(0));
    }

}